<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>intro-2-js</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h2 id="v1---getting-started">V1 - Getting started</h2>
    <ul>
      <li>Arrays are lists: <code>['Item 1', 'Item 2', 'Item 3']</code>.</li>
      <li>
        Variables are nicknames for data:
        <code>var todos = ['Item 1', 'Item 2', 'Item 3']</code>.
      </li>
      <li>
        Semicolons act sort of like periods do in English. They don’t appear at
        the end of every line though.
      </li>
      <li>
        Proper semicolon usage is particularly important when you are saving to
        a file, so pay close attention to how I use semicolons in
        <code>todoList.html</code>. I’ll note exceptions as we get to them.
      </li>
      <li>
        You can ignore my semicolon usage in the console since I treat that
        environment like a temporary scratchpad/whiteboard.
      </li>
      <li>
        Use <code>console.log</code> to display data in the console. Example:
        <code>console.log('hi hi hi!')</code>.
      </li>
      <li>Computers start counting from 0, not 1.</li>
      <li>
        On an array, use <code>.push</code> to add data to the end of the array.
        Example: <code>myArray.push('new data')</code>.
      </li>
      <li>
        Get an element at a certain position: <code>array[position]</code>.
      </li>
      <li>
        Change an element at a certain position:
        <code>array[position] = 'changed!</code>.
      </li>
      <li>
        Remove an element at a certain position:
        <code>array.splice(position, 1)</code>.
      </li>
    </ul>
    <h2 id="functions---interlude">Functions - Interlude</h2>
    <ul>
      <li>
        Characteristic 1: Functions group multiple lines of code together under
        a single name.
      </li>
    </ul>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="co">// Declaring a function.</span></a>
<a class="sourceLine" id="cb1-2" title="2"><span class="kw">function</span> <span class="at">functionName</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb1-3" title="3">  <span class="co">// Body of function. You can put 0 or more</span></a>
<a class="sourceLine" id="cb1-4" title="4">  <span class="co">// lines of code between the curly braces.</span></a>
<a class="sourceLine" id="cb1-5" title="5"><span class="op">}</span></a>
<a class="sourceLine" id="cb1-6" title="6"></a>
<a class="sourceLine" id="cb1-7" title="7"><span class="co">// To run the function, add a set of parentheses to the function name.</span></a>
<a class="sourceLine" id="cb1-8" title="8"><span class="at">functionName</span>()<span class="op">;</span></a></code></pre>
    </div>
    <ul>
      <li>
        Characteristic 2: When you a run a function, you can provide the
        function with data.
      </li>
    </ul>
    <div class="sourceCode" id="cb2">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb2-1" title="1"><span class="co">// myData is a parameter. Parameters differ from variables in two ways:</span></a>
<a class="sourceLine" id="cb2-2" title="2"><span class="co">// 1. Parameters are declared at the same time a function is created.</span></a>
<a class="sourceLine" id="cb2-3" title="3"><span class="co">// 2. Parameters are assigned a value only when the function is run.</span></a>
<a class="sourceLine" id="cb2-4" title="4"><span class="kw">function</span> <span class="at">demoFunction</span>(myData) <span class="op">{</span></a>
<a class="sourceLine" id="cb2-5" title="5">  <span class="va">console</span>.<span class="at">log</span>(myData)<span class="op">;</span></a>
<a class="sourceLine" id="cb2-6" title="6"><span class="op">}</span></a>
<a class="sourceLine" id="cb2-7" title="7"></a>
<a class="sourceLine" id="cb2-8" title="8"><span class="at">demoFunction</span>(<span class="st">&quot;gordon&quot;</span>)<span class="op">;</span> <span class="co">// myData = &#39;gordon&#39;</span></a>
<a class="sourceLine" id="cb2-9" title="9"><span class="at">demoFunction</span>(<span class="st">&quot;watch and code&quot;</span>)<span class="op">;</span> <span class="co">// myData = &#39;watch and code&#39;</span></a>
<a class="sourceLine" id="cb2-10" title="10"></a>
<a class="sourceLine" id="cb2-11" title="11"><span class="co">// Notice that we do NOT use semicolons after the opening</span></a>
<a class="sourceLine" id="cb2-12" title="12"><span class="co">// and closing curly braces in function declarations.</span></a></code></pre>
    </div>
    <h2 id="v2---using-functions">V2 - Using functions</h2>
    <ul>
      <li>Functions can have 0, 1, or <em>more</em> parameters.</li>
    </ul>
    <div class="sourceCode" id="cb3">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb3-1" title="1"><span class="kw">function</span> <span class="at">edit</span>(position<span class="op">,</span> newValue) <span class="op">{</span></a>
<a class="sourceLine" id="cb3-2" title="2">  todos[position] <span class="op">=</span> newValue<span class="op">;</span></a>
<a class="sourceLine" id="cb3-3" title="3">  <span class="va">console</span>.<span class="at">log</span>(todos)<span class="op">;</span></a>
<a class="sourceLine" id="cb3-4" title="4"><span class="op">}</span></a></code></pre>
    </div>
    <h2 id="the-computers-perspective---interlude">
      The computer’s perspective - Interlude
    </h2>
    <ul>
      <li>
        To understand the computer’s perspective, you need to understand every
        little thing that happens in each line of code. To do this, you must
        learn how to use the debugger effectively.
      </li>
      <li>
        When I see the “Step over” button, I think “step over to next line of
        code that’s about to run”.
      </li>
      <li>
        When you hit “Step over”, you will not necessarily go to the next line
        of code in the file. You have to think about what will happen.
      </li>
      <li>
        The “Resume script execution” is sorta of like an unpause button. It’ll
        exit the debugger or go to the next breakpoint (if there is one).
      </li>
      <li>
        Delusional thinking is not compatible with success (programming or
        otherwise).
      </li>
      <li>
        Use the expectations/reality framework (along with the debugger) to
        improve the quality of your thinking.
      </li>
      <li>
        Use “Step into” to go into any function call <em>except</em> built-in
        functions.
      </li>
      <li>
        Use the <code>debugger</code> statement to set breakpoints in the
        console without writing to a file.
      </li>
    </ul>
    <h2 id="questions-and-quality---interlude">
      Questions and quality - Interlude
    </h2>
    <ul>
      <li>
        Ask high quality questions. How you approach this will be a deciding
        factor in how good you will be.
      </li>
      <li>
        Throughout your journey learning to program (or with anything really),
        you will be faced with choices like this. One path leads to high
        ability, the other path leads to low ability. Choose wisely.
      </li>
    </ul>
    <h2 id="functions-and-variables---interlude">
      Functions and variables - Interlude
    </h2>
    <ul>
      <li>
        If you’re inside of a function, you can look out and see data, but the
        opposite isn’t true. If you’re outside, you can’t look in.
      </li>
      <li>
        Whenever you’re in doubt, draw circles and arrows. Arrows can only exit
        circles; they can never go in.
      </li>
      <li>“Scope” is a fancy term for describing variable visibility.</li>
    </ul>
    <h2 id="v3---using-objects">V3 - Using objects</h2>
    <ul>
      <li><code>true</code> and <code>false</code> are boolean values.</li>
      <li>Use objects to group related data together</li>
    </ul>
    <div class="sourceCode" id="cb4">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb4-1" title="1"><span class="kw">var</span> todo <span class="op">=</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb4-2" title="2">  <span class="dt">todoText</span><span class="op">:</span> <span class="st">&quot;Get groceries&quot;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb4-3" title="3">  <span class="dt">completed</span><span class="op">:</span> <span class="kw">false</span><span class="op">,</span></a>
<a class="sourceLine" id="cb4-4" title="4"><span class="op">};</span></a>
<a class="sourceLine" id="cb4-5" title="5"></a>
<a class="sourceLine" id="cb4-6" title="6"><span class="co">// Access properties with dot notation.</span></a>
<a class="sourceLine" id="cb4-7" title="7"><span class="va">console</span>.<span class="at">log</span>(<span class="va">todo</span>.<span class="at">todoText</span>)<span class="op">;</span> <span class="co">// &#39;Get groceries&#39;</span></a>
<a class="sourceLine" id="cb4-8" title="8"><span class="va">console</span>.<span class="at">log</span>(<span class="va">todo</span>.<span class="at">completed</span>)<span class="op">;</span> <span class="co">// false</span></a></code></pre>
    </div>
    <h2 id="v4---toggling">V4 - Toggling</h2>
    <ul>
      <li>
        Comparisons: Use <code>===</code> to see if two things are equal to each
        other.
      </li>
      <li>Use if statements to conditionally run chunks of code.</li>
    </ul>
    <div class="sourceCode" id="cb5">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb5-1" title="1"><span class="cf">if</span> (<span class="kw">true</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb5-2" title="2">  <span class="va">console</span>.<span class="at">log</span>(<span class="st">&quot;This line of code will run.&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb5-3" title="3"><span class="op">}</span></a>
<a class="sourceLine" id="cb5-4" title="4"></a>
<a class="sourceLine" id="cb5-5" title="5"><span class="cf">if</span> (<span class="kw">false</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb5-6" title="6">  <span class="va">console</span>.<span class="at">log</span>(<span class="st">&quot;This line of code will not run.&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb5-7" title="7"><span class="op">}</span></a>
<a class="sourceLine" id="cb5-8" title="8"></a>
<a class="sourceLine" id="cb5-9" title="9"><span class="co">// Notice that we do NOT use semicolons after the opening</span></a>
<a class="sourceLine" id="cb5-10" title="10"><span class="co">// and closing curly braces in if statements.</span></a></code></pre>
    </div>
    <ul>
      <li>
        <code>if/else</code> statements offer another way to structure
        conditional logic.
      </li>
    </ul>
    <div class="sourceCode" id="cb6">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb6-1" title="1"><span class="cf">if</span> (condition) <span class="op">{</span></a>
<a class="sourceLine" id="cb6-2" title="2">  <span class="co">// Will run if condition is true.</span></a>
<a class="sourceLine" id="cb6-3" title="3"><span class="op">}</span> <span class="cf">else</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb6-4" title="4">  <span class="co">// Will run if condition is false.</span></a>
<a class="sourceLine" id="cb6-5" title="5"><span class="op">}</span></a></code></pre>
    </div>
    <h2 id="data-types-and-comparisons---interlude">
      Data types and comparisons - Interlude
    </h2>
    <ul>
      <li>JavaScript has two broad types of data, objects and primitives.</li>
      <li>
        Objects can be as complex as you want. Examples include arrays and
        functions.
      </li>
      <li>Primitives are the simple building blocks of the language.</li>
      <li>
        There are five main primitives: strings, numbers, booleans, undefined,
        and null.
      </li>
      <li>
        Comparisons with primitives work how most people would expect (like math
        class).
      </li>
      <li>Comparisons with objects work very differently.</li>
      <li>
        Make sure you understand why <code>[1, 2, 3] === [1, 2, 3]</code> is
        <code>false</code>.
      </li>
    </ul>
    <h2 id="v5---displaying-data-better">V5 - Displaying data better</h2>
    <ul>
      <li>Use a for-loop to repeat a piece of code any number of times.</li>
    </ul>
    <div class="sourceCode" id="cb7">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb7-1" title="1"><span class="cf">for</span> (<span class="kw">var</span> i <span class="op">=</span> <span class="dv">0</span><span class="op">;</span> i <span class="op">&lt;</span> <span class="dv">5</span><span class="op">;</span> i<span class="op">++</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb7-2" title="2">  <span class="va">console</span>.<span class="at">log</span>(i)<span class="op">;</span></a>
<a class="sourceLine" id="cb7-3" title="3">  <span class="co">// 0</span></a>
<a class="sourceLine" id="cb7-4" title="4">  <span class="co">// 1</span></a>
<a class="sourceLine" id="cb7-5" title="5">  <span class="co">// 2</span></a>
<a class="sourceLine" id="cb7-6" title="6">  <span class="co">// 3</span></a>
<a class="sourceLine" id="cb7-7" title="7">  <span class="co">// 4</span></a>
<a class="sourceLine" id="cb7-8" title="8"><span class="op">}</span></a>
<a class="sourceLine" id="cb7-9" title="9"></a>
<a class="sourceLine" id="cb7-10" title="10"><span class="co">// Notice that we do NOT use semicolons after the opening</span></a>
<a class="sourceLine" id="cb7-11" title="11"><span class="co">// and closing curly braces in for-loops.</span></a></code></pre>
    </div>
    <h2 id="v6---toggle-all">V6 - Toggle all</h2>
    <ul>
      <li>
        Boolean logic can be complicated. Make sure that you carefully think
        about different situations before you start coding.
      </li>
    </ul>
    <h2 id="v7---buttons">V7 - Buttons!</h2>
    <ul>
      <li>
        HTML syntax for buttons:
        <code>&lt;button&gt;My button&lt;/button&gt;</code>.
      </li>
      <li>Vocab lesson: A function on an object is called a “method”.</li>
    </ul>
    <div class="sourceCode" id="cb8">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb8-1" title="1"><span class="kw">var</span> gordon <span class="op">=</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb8-2" title="2">  <span class="dt">name</span><span class="op">:</span> <span class="st">&quot;Gordon&quot;</span><span class="op">,</span> <span class="co">// property</span></a>
<a class="sourceLine" id="cb8-3" title="3">  <span class="dt">city</span><span class="op">:</span> <span class="st">&quot;San Francisco&quot;</span><span class="op">,</span> <span class="co">// property</span></a>
<a class="sourceLine" id="cb8-4" title="4">  <span class="dt">myMethod</span><span class="op">:</span> <span class="kw">function</span> <span class="at">sayHi</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb8-5" title="5">    <span class="co">// method</span></a>
<a class="sourceLine" id="cb8-6" title="6">    <span class="va">console</span>.<span class="at">log</span>(<span class="st">&quot;Hi&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb8-7" title="7">  <span class="op">},</span></a>
<a class="sourceLine" id="cb8-8" title="8"><span class="op">};</span></a></code></pre>
    </div>
    <ul>
      <li>
        Use the <code>document</code> object to access the webpage in your
        JavaScript.
      </li>
      <li>
        Use the <code>document.getElementById</code> method to grab an element
        by id.
      </li>
    </ul>
    <div class="sourceCode" id="cb9">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb9-1" title="1"><span class="kw">var</span> displayTodosButton <span class="op">=</span> <span class="va">document</span>.<span class="at">getElementById</span>(<span class="st">&quot;display-todos-button&quot;</span>)<span class="op">;</span></a></code></pre>
    </div>
    <ul>
      <li>
        Elements have a <code>addEventListener</code> method, which can be used
        to respond to events.
      </li>
    </ul>
    <div class="sourceCode" id="cb10">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb10-1" title="1"><span class="co">// The first argument is an event type.</span></a>
<a class="sourceLine" id="cb10-2" title="2"><span class="co">// The second argument is a function that&#39;ll run</span></a>
<a class="sourceLine" id="cb10-3" title="3"><span class="co">// whenever the event occurs on the element.</span></a>
<a class="sourceLine" id="cb10-4" title="4"><span class="co">// In this example, whenever the displayTodosButton is clicked,</span></a>
<a class="sourceLine" id="cb10-5" title="5"><span class="co">// the displayTodos function will run.</span></a>
<a class="sourceLine" id="cb10-6" title="6"><span class="va">displayTodosButton</span>.<span class="at">addEventListener</span>(<span class="st">&quot;click&quot;</span><span class="op">,</span> displayTodos)<span class="op">;</span></a></code></pre>
    </div>
    <h2 id="experimenting-with-functions---interlude">
      Experimenting with functions - Interlude
    </h2>
    <ul>
      <li>
        You need to get to the point where the results of these experiments are
        obvious and familiar to you.
      </li>
    </ul>
    <div class="sourceCode" id="cb11">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb11-1" title="1"><span class="kw">function</span> <span class="at">demoFunction</span>() <span class="op">{}</span></a>
<a class="sourceLine" id="cb11-2" title="2"></a>
<a class="sourceLine" id="cb11-3" title="3"><span class="kw">var</span> experiment1 <span class="op">=</span> demoFunction<span class="op">;</span> <span class="co">// ?</span></a>
<a class="sourceLine" id="cb11-4" title="4"><span class="kw">var</span> experiment2 <span class="op">=</span> <span class="at">demoFunction</span>()<span class="op">;</span> <span class="co">// ?</span></a>
<a class="sourceLine" id="cb11-5" title="5"></a>
<a class="sourceLine" id="cb11-6" title="6"><span class="kw">function</span> <span class="at">demoFunctionThatReturnsAString</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb11-7" title="7">  <span class="cf">return</span> <span class="st">&quot;a string&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb11-8" title="8"><span class="op">}</span></a>
<a class="sourceLine" id="cb11-9" title="9"></a>
<a class="sourceLine" id="cb11-10" title="10"><span class="kw">var</span> experiment3 <span class="op">=</span> demoFunctionThatReturnsAString<span class="op">;</span> <span class="co">// ?</span></a>
<a class="sourceLine" id="cb11-11" title="11"><span class="kw">var</span> experiment4 <span class="op">=</span> <span class="at">demoFunctionThatReturnsAString</span>()<span class="op">;</span> <span class="co">// ?</span></a>
<a class="sourceLine" id="cb11-12" title="12"></a>
<a class="sourceLine" id="cb11-13" title="13"><span class="kw">function</span> <span class="at">demoFunctionThatReturnsUndefined</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb11-14" title="14">  <span class="cf">return</span> <span class="kw">undefined</span><span class="op">;</span></a>
<a class="sourceLine" id="cb11-15" title="15"><span class="op">}</span></a>
<a class="sourceLine" id="cb11-16" title="16"></a>
<a class="sourceLine" id="cb11-17" title="17"><span class="kw">var</span> experiment5 <span class="op">=</span> demoFunctionThatReturnsUndefined<span class="op">;</span> <span class="co">// ?</span></a>
<a class="sourceLine" id="cb11-18" title="18"><span class="kw">var</span> experiment6 <span class="op">=</span> <span class="at">demoFunctionThatReturnsUndefined</span>()<span class="op">;</span> <span class="co">// ?</span></a>
<a class="sourceLine" id="cb11-19" title="19"></a>
<a class="sourceLine" id="cb11-20" title="20"><span class="kw">function</span> <span class="at">logThis</span>(thing) <span class="op">{</span></a>
<a class="sourceLine" id="cb11-21" title="21">  <span class="va">console</span>.<span class="at">log</span>(thing)<span class="op">;</span></a>
<a class="sourceLine" id="cb11-22" title="22"><span class="op">}</span></a>
<a class="sourceLine" id="cb11-23" title="23"></a>
<a class="sourceLine" id="cb11-24" title="24"><span class="co">// Experiment 7</span></a>
<a class="sourceLine" id="cb11-25" title="25"><span class="at">logThis</span>(demoFunctionThatReturnsAString)<span class="op">;</span> <span class="co">// ?</span></a>
<a class="sourceLine" id="cb11-26" title="26"></a>
<a class="sourceLine" id="cb11-27" title="27"><span class="co">// Experiment 8</span></a>
<a class="sourceLine" id="cb11-28" title="28"><span class="at">logThis</span>(<span class="at">demoFunctionThatReturnsAString</span>())<span class="op">;</span> <span class="co">// ?</span></a></code></pre>
    </div>
    <h2 id="v8---getting-data-from-inputs">V8 - Getting data from inputs</h2>
    <ul>
      <li>In your HTML, use <code>&lt;input&gt;</code> to get user input.</li>
      <li>
        In your JavaScript, use <code>input.value</code> to get/set an input’s
        value.
      </li>
    </ul>
    <h2 id="v9---escape-from-the-console">V9 - Escape from the console</h2>
    <ul>
      <li>
        In HTML, use <code>ul</code>s and <code>li</code>s for listing data.
      </li>
    </ul>
    <pre><code>&lt;ul&gt;
  &lt;li&gt;First&lt;/li&gt;
  &lt;li&gt;Second&lt;/li&gt;
  &lt;li&gt;Third&lt;/li&gt;
&lt;/ul&gt;</code></pre>
    <ul>
      <li>
        Use <code>document.createElement</code> to create elements in
        JavaScript.
      </li>
    </ul>
    <div class="sourceCode" id="cb13">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb13-1" title="1"><span class="kw">var</span> todoLi <span class="op">=</span> <span class="va">document</span>.<span class="at">createElement</span>(<span class="st">&quot;li&quot;</span>)<span class="op">;</span></a></code></pre>
    </div>
    <ul>
      <li>
        Use the <code>appendChild</code> method to add elements to the page.
      </li>
    </ul>
    <div class="sourceCode" id="cb14">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb14-1" title="1"><span class="kw">var</span> todosUl <span class="op">=</span> <span class="va">document</span>.<span class="at">getElementById</span>(<span class="st">&quot;todos-ul&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb14-2" title="2"><span class="va">todosUl</span>.<span class="at">appendChild</span>(todoLi)<span class="op">;</span></a></code></pre>
    </div>
    <ul>
      <li>
        Use the <code>innerHTML</code> property to get/set an element’s html.
      </li>
      <li>
        Use the <code>innerText</code> property to get/set an element’s text.
      </li>
      <li>Use <code>+</code> to combine strings.</li>
    </ul>
    <h2 id="v10---click-to-delete">V10 - Click to delete</h2>
    <ul>
      <li>
        Went through the pros/cons of different ways to access the remove button
        that was clicked. Making informed tradeoffs is one of the most important
        skills that you will learn.
      </li>
      <li>
        Functions passed to <code>addEventListener</code> are called with an
        event object, which describes the event that occurred.
      </li>
    </ul>
    <div class="sourceCode" id="cb15">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb15-1" title="1"><span class="kw">function</span> <span class="at">remove</span>(event) <span class="op">{</span></a>
<a class="sourceLine" id="cb15-2" title="2">  <span class="co">// We used event.currentTarget to access the remove button element that was clicked.</span></a>
<a class="sourceLine" id="cb15-3" title="3">  <span class="co">// Elements have an id property we can use to get/set the id.</span></a>
<a class="sourceLine" id="cb15-4" title="4">  <span class="kw">var</span> position <span class="op">=</span> <span class="va">event</span>.<span class="va">currentTarget</span>.<span class="at">id</span><span class="op">;</span></a>
<a class="sourceLine" id="cb15-5" title="5">  <span class="va">todos</span>.<span class="at">splice</span>(position<span class="op">,</span> <span class="dv">1</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb15-6" title="6">  <span class="at">displayTodos</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb15-7" title="7"><span class="op">}</span></a></code></pre>
    </div>
    <h2 id="v11---click-to-toggle">V11 - Click to toggle</h2>
    <ul>
      <li>Element ids should be unique.</li>
      <li>
        Practiced thinking through the pros/cons of different ways to extract
        position from ids.
      </li>
    </ul>
    <div class="sourceCode" id="cb16">
      <pre
        class="sourceCode javascript"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb16-1" title="1"><span class="co">// We ended up choosing this technique.</span></a>
<a class="sourceLine" id="cb16-2" title="2"><span class="kw">var</span> idString <span class="op">=</span> <span class="st">&quot;todo-0&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb16-3" title="3"><span class="kw">var</span> position <span class="op">=</span> <span class="va">idString</span>.<span class="at">split</span>(<span class="st">&quot;-&quot;</span>)[<span class="dv">1</span>]<span class="op">;</span></a></code></pre>
    </div>
    <h2 id="v12---click-to-edit">V12 - Click to edit</h2>
    <ul>
      <li><code>prompt()</code> is a simple way to get user input.</li>
      <li>Use <code>!==</code> to test for inequality.</li>
      <li>Use <code>&amp;&amp;</code> to combine comparisons.</li>
    </ul>
  </body>
</html>
